package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENECASHCLOSEDETAIL*/
@Entity(name="TgeneCashCloseDetail")
@Table(name="TGENECASHCLOSEDETAIL")
public class TgeneCashCloseDetail extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneCashCloseDetail
*/
@EmbeddedId
private TgeneCashCloseDetailKey pk;
@Column(name="QUANTITY", nullable=true)

/**
* Numero de billetes o monedas por denominacion
*/
private Integer quantity;

@Column(name="TOTAL", nullable=true)

/**
* Total de la denominacion
*/
private BigDecimal total;

/**Contructor por defecto*/
public TgeneCashCloseDetail(){
}
/**Contructor de TgeneCashCloseDetail
@param pPk Clave Primaria del entity
*/
public TgeneCashCloseDetail(TgeneCashCloseDetailKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneCashCloseDetail
*/
public static TgeneCashCloseDetail find(EntityManager pEntityManager,TgeneCashCloseDetailKey pKey) throws Exception{
    TgeneCashCloseDetail obj = pEntityManager.find(TgeneCashCloseDetail.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneCashCloseDetail
@return El objeto que referencia a la Clave primaria de TgeneCashCloseDetail
*/
public TgeneCashCloseDetailKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneCashCloseDetail
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneCashCloseDetail
*/
public void setPk(TgeneCashCloseDetailKey pPk){
  pk=pPk;
}
/**Obtiene el valor de quantity
@return valor de quantity*/
public Integer getQuantity(){
  return quantity;
}
/**Fija el valor de quantity
@param pQuantity nuevo Valor de quantity*/
public void setQuantity(Integer pQuantity){
  quantity=pQuantity;
}

/**Obtiene el valor de total
@return valor de total*/
public BigDecimal getTotal(){
  return total;
}
/**Fija el valor de total
@param pTotal nuevo Valor de total*/
public void setTotal(BigDecimal pTotal){
  total=pTotal;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneCashCloseDetail))return false;
    TgeneCashCloseDetail that = (TgeneCashCloseDetail) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneCashCloseDetail
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneCashCloseDetail
*/
public Object createInstance(){
 TgeneCashCloseDetail instance=new TgeneCashCloseDetail();	
 instance.setPk(new TgeneCashCloseDetailKey());
 return instance;
}
/**Clona la entidad TgeneCashCloseDetail
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneCashCloseDetail p=(TgeneCashCloseDetail)this.clone();
  p.setPk((TgeneCashCloseDetailKey)this.pk.cloneMe());
  return p;
}
}
